#define String (List Char)
module
export Texpr, Binding, Atype, Const, Qual, Fixid, Import;
rec type Texpr =
	  mkap Texpr Texpr		
	+ mklam Texpr Texpr
	+ mkcase Texpr (List (Texpr#Texpr))
	+ mkletv Binding Texpr
	+ mkident Id
	+ mkmodule Id (List Fixid) (List Impid) (List Expid) Binding
	+ mkconst Const
	+ mkerror String
	+ mkas Id Texpr	-- Only in patterns
	+ mkcondp Texpr Texpr	-- Only in patterns
	+ mklazyp Texpr -- Only in patterns
	-- the following variants are not part of the abstract syntax, but
	-- are added later by transformations
	+ mkconstr Constr (List Texpr)
	+ mkfailmatch Int
	+ mkinfo Teinfo Texpr
	+ mklistf Int (List Texpr)
	+ mklistg Texpr (List Qual)
	+ mkhmodule Id (Option (List Expid)) (List Import) (List Fixid) Binding
and type Fixid = mkfixid (List Id) Fixity
and type Import = mkimport Id (List Impid) (List Fixid) (List Impid) Bool (List Expid) (List (Id#Id))
and type Binding =
	  mkbtype Ttype (List Atype) (Option (List Id))		-- type, constructor, derived insts
	+ mkbpat (List (Texpr#Texpr))
	+ mkbmulti Texpr Texpr
	+ mkband Binding Binding
	+ mkbrec Binding
	+ mkberror String
	+ mkblocal Binding Binding
	+ mkbnull		-- nothing bound
	+ mkbsyn Ttype Ttype
	+ mkbclass CDecl Binding
	+ mkbinstance IDecl Binding (Option Id)			-- type, bindings, and id for vector (after rename)
	+ mkbdefault (List Ttype)
	+ mkbsign (List Id) Ttype
and type Atype =
	  mkcons Id (List (Ttype#Bool))
and type Qual =
          mkqgen Texpr Texpr
	+ mkqfilter Texpr
and type Const =
	  cint Int
	+ cchar Char
	+ cstring String
	+ cfloat String
	+ cinteger String
	+ crational String
end
