module
#include <OK>
#include "../misc/flags.t"
#include "../expr/read.t"
#include "../expr/id.t"
#include "../expr/ttype.t.t"
#include "../expr/ttype.t"
#include "../expr/types.t.t"
#include "Cexpr.t"
#include "loadmodule.t"
#include "iload.t"
export libs, Command, topparse;
rec type Command = 
	Com_eval Texpr + 
	Com_bind Binding + 
	Com_load (List Char) (List Impid) +
	Com_mload Texpr +
	Com_end + 
	Com_empty +
	Com_msg (List Char) +
	Com_msgnp (List Char)
and readl s =
	case openfile s in
	   No e : fail (e@" "@s)
	|| Yes s : choplist (splitat '\n') s
	end
and lib =
	case getenv "LMLDIR" in
	   No _ : "/usr/local/lib/lmlc/lib/"
	|| Yes s : s @ "/lib/"
	end
and libo = map (lib @) (rev (readl (lib@if Curry then "lib.oindexc" else "lib.oindex")))
and conv (n, v) = (idasm n, Comb n v)
and rec check [] a = Yes a
||      check (No s._) _ = No s
||      check (Yes xs.ls) a = check ls (map conv xs@a)
and loadlibs ms =
	check (map loadmodule ms) []
and libs = loadlibs libo
and     topparse "" = (Com_end, "")
||      topparse (' '.l) = topparse l
||      topparse ('^'.' '.l) = (Com_empty, l)
||      topparse ('|'.' '.l) =
	let (ll, mkconst (cstring s)) = readexpr l in
	let (lll, imps) = readimplist ll in
	(Com_load s imps, lll)
||	topparse ('@'.' '.l) =
	let (ll, e) = readexpr l in
	(Com_mload e, ll)
||      topparse ('{'.' '.l) =
	let (ll, e) = readexpr l in
	(Com_eval e, ll)
||      topparse ('}'.' '.l) =
	let (ll, b) = readbinding l
	in (Com_bind b, ll)
||	topparse ('`'.' '.l) =
	let (ll, mkconst (cstring s)) = readexpr l in
	(Com_msg s, ll)
||	topparse ('/'.' '.l) =
	let (ll, mkconst (cstring s)) = readexpr l in
	(Com_msgnp s, ll)
||	topparse s = fail ("Bad input!! '" @ s @ "'\n")
end
